From 7890a230953c081d93c806c8a802aa69452d7e28 Mon Sep 17 00:00:00 2001
From: Peter Seibel <peter@gigamonkeys.com>
Date: Fri, 3 Jan 2025 15:56:01 -0800
Subject: [PATCH] Allow pcomplete of git add to include untracked files.

---
 lisp/pcmpl-git.el | 12 +++++++++++-
 1 file changed, 11 insertions(+), 1 deletion(-)

diff --git a/lisp/pcmpl-git.el b/lisp/pcmpl-git.el
index f57c2d5470a..498918ac1c4 100644
--- a/lisp/pcmpl-git.el
+++ b/lisp/pcmpl-git.el
@@ -82,8 +82,18 @@ Files listed by `git ls-files ARGS' satisfy the predicate."
                   (pcomplete-from-help `(,vc-git-program "help" ,subcmd)
                                        :argument
                                        "-+\\(?:\\[no-\\]\\)?[a-z-]+=?"))))
+               ;; Complete modified tracked files and untracked files
+               ("add"
+                (pcomplete-here
+                 (pcomplete-entries
+                  nil (let ((modified (pcmpl-git--tracked-file-predicate "-m"))
+                            (untracked (pcmpl-git--tracked-file-predicate "-o" "--exclude-standard")))
+                        (lambda (file)
+                          (or
+                           (and modified (funcall modified file))
+                           (and untracked (funcall untracked file))))))))
                ;; Complete modified tracked files
-               ((or "add" "commit" "restore")
+               ((or "commit" "restore")
                 (pcomplete-here
                  (pcomplete-entries
                   nil (pcmpl-git--tracked-file-predicate "-m"))))
-- 
2.47.1

